//+----------------------------------------------------------------------------+
//|                                                           e-Trailing2.mq4  |
//|                                                                            |
//|                                                      . aka KimIV  |
//|                                                       http://www.kimiv.ru  |
//|                                                                            |
//|  27.10.2008      .                 |
//+----------------------------------------------------------------------------+
#property copyright "  . aka KimIV"
#property link  "http://www.kimiv.ru"

//-------    -----------------------------------------+
extern string _P_Expert = "----------  ";
extern bool   AllSymbols   = True;     //     
extern int    Magic        = -1;       //  
extern bool   TSProfitOnly = True;     //   
extern int    TStop.Buy    = 2;       //      
extern int    TStop.Sell   = 2;       //      
extern int    TrailingStep = 10;        //    
extern bool   HiddenSLandTP = true;
extern int    Slippage = 4;
extern bool   ShowComment  = True;     //  

//-------     ------------------------------+
extern string _P_Performance = "----------  ";
extern bool   UseSound     = True;          //   
extern string SoundSuccess = "expert.wav";  //  
extern string SoundError   = "timeout.wav"; //  
extern int    NumberOfTry  = 2;             //   

//-------    -------------------------------------+
bool   gbDisabled   = False;           //   
bool   gbNoInit     = False;           //   
color  clModifyBuy  = Aqua;            //    
color  clModifySell = Tomato;          //    

double osl[10000],otp[10000];
string ScreenComment[61],Screen[2][124];
int i1,i2,i3,i4,i5,i6,i9,Arrow[3];
bool Trade[61];

//-------    -----------------------------------------+
#include <stdlib.mqh>


//+----------------------------------------------------------------------------+
//|                                                                            |
//|  ˨                                                   |
//|                                                                            |
//+----------------------------------------------------------------------------+
//|  expert initialization function                                            |
//+----------------------------------------------------------------------------+
void init() {
Arrow[1]=0x003300; Arrow[2]=0x0000FF;
i1=1; while(i1<=60) {ScreenComment[i1]=StringConcatenate("Comment",i1); 
ObjectCreate(ScreenComment[i1],23,0,0,0); i1++;}

  gbNoInit=False;
  if (!IsTradeAllowed()) {
    Message("    \n"+
            "  ");
    gbNoInit=True; return;
  }
  if (!IsLibrariesAllowed()) {
    Message("    \n"+
            "    ");
    gbNoInit=True; return;
  }
  if (!IsTesting()) {
    if (IsExpertEnabled()) Message("    ");
    else Message("  \"  \"");
  }
  start();
}

//+----------------------------------------------------------------------------+
//|  expert deinitialization function                                          |
//+----------------------------------------------------------------------------+
void deinit() {
  if (!IsTesting()) Comment("");
}

//+----------------------------------------------------------------------------+
//|  expert start function                                                     |
//+----------------------------------------------------------------------------+
void start() {
  if (gbDisabled) {
    Message(" !  !"); return;
  }
  if (gbNoInit) {
    Message("   !"); return;
  }
  if (ShowComment) {
    Comment(IIFs(AllSymbols, "AllSymbols  ", "")
           ,"Magic="+IIFs(Magic<0, "", DoubleToStr(Magic, 0))+"  "
           ,IIFs(TSProfitOnly, "TSProfitOnly  ", "")
           ,"TStop.Buy="+DoubleToStr(TStop.Buy, 0)+"  "
           ,"TStop.Sell="+DoubleToStr(TStop.Sell, 0)+"  "
           ,"TrailingStep="+DoubleToStr(TrailingStep, 0)+"  "
           );
  } else Comment("");

  string sy=IIFs(AllSymbols, "", NULL);
  SimpleTrailing(sy, -1, Magic);
  
  //if (i6==0)
  //{i1=1; while(i1<=6)
  //{OrderSend(Symbol(),OP_BUY,0.1,Ask,Slippage,0,0,"1",Magic,0,Arrow[1]);
  //OrderSend(Symbol(),OP_SELL,0.1,Bid,Slippage,0,0,"1",Magic,0,Arrow[2]); 
  //i1++;} i6=1;}
// Stop loss and take profit order close ***********************************************************************************
i1=1; while(i1<=60) {Screen[0][i1]=""; i1++;}
i5=1; i9=OrdersTotal()-1; while(i9>=0)
{if (OrderSelect(i9,SELECT_BY_POS,MODE_TRADES) && HiddenSLandTP && (OrderSymbol()==Symbol() || AllSymbols) && (OrderMagicNumber()==Magic || Magic<0))
{Screen[1][1]=DoubleToStr(OrderTicket(),0); i3=(StringLen(Screen[1][1])>4)*(StringLen(Screen[1][1])-4);
Screen[1][2]=StringSubstr(Screen[1][1],i3,4); i4=StrToInteger(Screen[1][2]);
if (OrderType()==0)
{if (otp[i4]>0) {Screen[0][i5]=StringConcatenate("\nLong order ",OrderTicket()," hidden take profit ",otp[i4]); i5++;}
if (osl[i4]>0) {Screen[0][i5]=StringConcatenate("\nLong order ",OrderTicket()," hidden stop loss ",osl[i4]," ",i4); i5++;}
if (otp[i4]!=0 && Bid>=otp[i4])
{OrderClose(OrderTicket(),OrderLots(),Bid,Slippage,Arrow[1]);}
if (osl[i4]!=0 && Bid<=osl[i4])
{OrderClose(OrderTicket(),OrderLots(),Bid,Slippage,Arrow[1]);}}
if (OrderType()==1)
{if (otp[i4]>0) {Screen[0][i5]=StringConcatenate("\nShort order ",OrderTicket()," hidden take profit ",otp[i4]); i5++;}
if (osl[i4]>0) {Screen[0][i5]=StringConcatenate("\nShort order ",OrderTicket()," hidden stop loss ",osl[i4]," ",i4); i5++;}
if (otp[i4]!=0 && Ask<=otp[i4])
{OrderClose(OrderTicket(),OrderLots(),Ask,Slippage,Arrow[2]);}
if (osl[i4]!=0 && Ask>=osl[i4])
{OrderClose(OrderTicket(),OrderLots(),Ask,Slippage,Arrow[2]);}}}
i9--;}

// Comment *********************************************************************************************************************
i2=22; i1=1; while(i1<=60) 
{ObjectSetText(ScreenComment[i1],Screen[0][i1],8,"Verdana",White); ObjectSet(ScreenComment[i1],OBJPROP_CORNER,0); 
ObjectSet(ScreenComment[i1],OBJPROP_XDISTANCE,2); ObjectSet(ScreenComment[i1],OBJPROP_YDISTANCE,i2);
if (Screen[0][i1]!="") {i2+=14;} i1++;}
}


//+----------------------------------------------------------------------------+
//|                                                                            |
//|                                                     |
//|                                                                            |
//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 01.09.2005                                                     |
//|   :                          |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    op -                                       |
//+----------------------------------------------------------------------------+
string GetNameOP(int op) {
  switch (op) {
    case OP_BUY      : return("Buy");
    case OP_SELL     : return("Sell");
    case OP_BUYLIMIT : return("BuyLimit");
    case OP_SELLLIMIT: return("SellLimit");
    case OP_BUYSTOP  : return("BuyStop");
    case OP_SELLSTOP : return("SellStop");
    default          : return("Unknown Operation");
  }
}

//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 18.07.2008                                                     |
//|   :        .      |
//+----------------------------------------------------------------------------+
color IIFc(bool condition, color ifTrue, color ifFalse) {
  if (condition) return(ifTrue); else return(ifFalse);
}

//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 01.02.2008                                                     |
//|   :        .      |
//+----------------------------------------------------------------------------+
string IIFs(bool condition, string ifTrue, string ifFalse) {
  if (condition) return(ifTrue); else return(ifFalse);
}

//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 01.09.2005                                                     |
//|   :                                  |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    m -                                                       |
//+----------------------------------------------------------------------------+
void Message(string m) {
  Comment(m);
  if (StringLen(m)>0) Print(m);
}

//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 28.11.2006                                                     |
//|   :     .           |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    pp -                                                 |
//|    sl -                                                 |
//|    tp -                                                 |
//|    ex -                                                       |
//+----------------------------------------------------------------------------+
void ModifyOrder(double pp=-1, double sl=0, double tp=0, datetime ex=0) {
  bool   fm;
  color  cl=IIFc(OrderType()==OP_BUY
              || OrderType()==OP_BUYLIMIT
              || OrderType()==OP_BUYSTOP, clModifyBuy, clModifySell);
  double op, pa, pb, os, ot;
  int    dg=MarketInfo(OrderSymbol(), MODE_DIGITS), er, it;

  if (pp<=0) pp=OrderOpenPrice();
  if (sl<0 ) sl=OrderStopLoss();
  if (tp<0 ) tp=OrderTakeProfit();
  
  pp=NormalizeDouble(pp, dg);
  sl=NormalizeDouble(sl, dg);
  tp=NormalizeDouble(tp, dg);
  op=NormalizeDouble(OrderOpenPrice() , dg);
  os=NormalizeDouble(OrderStopLoss()  , dg);
  ot=NormalizeDouble(OrderTakeProfit(), dg);

  if (pp!=op || sl!=os || tp!=ot) {
    for (it=1; it<=NumberOfTry; it++) {
      if (!IsTesting() && (!IsExpertEnabled() || IsStopped())) break;
      while (!IsTradeAllowed()) Sleep(5000);
      RefreshRates();
      if (HiddenSLandTP)
      {Screen[1][1]=DoubleToStr(OrderTicket(),0); i3=(StringLen(Screen[1][1])>4)*(StringLen(Screen[1][1])-4);
       Screen[1][2]=StringSubstr(Screen[1][1],i3,4); i4=StrToInteger(Screen[1][2]);
      osl[i4]=sl; otp[i4]=tp;}
      if (!HiddenSLandTP)
      {fm=OrderModify(OrderTicket(), pp, sl, tp, ex, cl);
      if (fm) {
        if (UseSound) PlaySound(SoundSuccess); break;
      } else {
        er=GetLastError();
        if (UseSound) PlaySound(SoundError);
        pa=MarketInfo(OrderSymbol(), MODE_ASK);
        pb=MarketInfo(OrderSymbol(), MODE_BID);
        Print("Error(",er,") modifying order: ",ErrorDescription(er),", try ",it);
        Print("Ask=",pa,"  Bid=",pb,"  sy=",OrderSymbol(),
              "  op="+GetNameOP(OrderType()),"  pp=",pp,"  sl=",sl,"  tp=",tp);
        Sleep(1000*10);}
      }
    }
  }
}

//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 11.09.2008                                                     |
//|   :                               |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    sy -     ( ""  -  ,                   |
//|                                     NULL -  )                 |
//|    op -                    ( -1  -  )                  |
//|    mn - MagicNumber                ( -1  -  )                    |
//+----------------------------------------------------------------------------+
void SimpleTrailing(string sy="", int op=-1, int mn=-1) {
  double po, pp;
  int    i, k=OrdersTotal();

  if (sy=="0") sy=Symbol();
  for (i=0; i<k; i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if ((OrderSymbol()==sy || sy=="") && (op<0 || OrderType()==op)) {
        po=MarketInfo(OrderSymbol(), MODE_POINT);
        if (mn<0 || OrderMagicNumber()==mn) {
         Screen[1][1]=DoubleToStr(OrderTicket(),0); i3=(StringLen(Screen[1][1])>4)*(StringLen(Screen[1][1])-4);
         Screen[1][2]=StringSubstr(Screen[1][1],i3,4); i4=StrToInteger(Screen[1][2]);
          if (OrderType()==OP_BUY) {
           pp=MarketInfo(OrderSymbol(), MODE_BID);
            if (!TSProfitOnly || pp-OrderOpenPrice()>TStop.Buy*po) {
              if ((!HiddenSLandTP)*OrderStopLoss()+(HiddenSLandTP)*osl[i4]<pp-(TStop.Buy+TrailingStep-1)*po) {
                ModifyOrder(-1, pp-TStop.Buy*po, -1);
              }
            }
          }
          if (OrderType()==OP_SELL) {
            pp=MarketInfo(OrderSymbol(), MODE_ASK);
            if (!TSProfitOnly || OrderOpenPrice()-pp>TStop.Sell*po) {
              if ((!HiddenSLandTP)*OrderStopLoss()+(HiddenSLandTP)*osl[i4]>pp+(TStop.Sell+TrailingStep-1)*po || (!HiddenSLandTP)*OrderStopLoss()+(HiddenSLandTP)*osl[i4]==0) {
                ModifyOrder(-1, pp+TStop.Sell*po, -1);
              }
            }
          }
        }
      }
    }
  }
}
//+----------------------------------------------------------------------------+

